#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/un.h>
#include <sys/socket.h>
#include <lib/util.h>
#include <router/ipqext/ipqextctl.h>

void ipqextctl_set_sockaddr(struct sockaddr_un *addr, char *pathname)
{
  memset(addr, 0, sizeof(struct sockaddr_un));
  addr->sun_family = AF_LOCAL;
  strncpy(addr->sun_path, pathname, sizeof(addr->sun_path) - 1);
}

int ipqextctl_init_socket(int type, char *pathname)
{
  struct sockaddr_un addr;
  int sd;

  unlink(pathname);
  
  if ((sd = socket(AF_LOCAL, type, 0)) == -1)
    ERR_RET(-1);

  ipqextctl_set_sockaddr(&addr, pathname);

  if (bind(sd, (struct sockaddr *) &addr, SUN_LEN(&addr)) != 0)
    ERR_RET(-1);

  return sd;
}

void ipqextctl_close_socket(int sd, char *pathname)
{
  close(sd);
  unlink(pathname);
}

void ipqextctl_show_request(ipqextctl_request_t *request)
{
  printf("request:  command = %d\n"
         "          extname = %s\n"
         "          param   = %s\n",
         request->command,
         request->extname,
         request->param);
}

void ipqextctl_show_response(ipqextctl_response_t *response)
{
  printf("response: status  = %d\n"
         "          extname = %s\n"
         "          param   = %s\n",
         response->status,
         response->extname,
         response->param);
}
